<?php

/*
+==========================================================================+
| Admin Secure Support Functions                                           |
| Version 1.0                                                              |
| Copyright (c) 2003 Madman                                                |
| http://gp4tweaker.vadertrophy.com                                        |
+--------------------------------------------------------------------------+
| Disclaimer: You run this package at your sole risk. Author cannot be     |
| held liable if anything goes wrong. You are advised to test this package |
| on a development system. Backup everything before implementing in a      |
| production environment. If something goes wrong, you can always backout  |
| and restore your backups.                                                |
|                                                                          |
| Terms and Conditions: Installing and running this also means you agree   |
| to the terms of usages and conditions to this package. As always, make   |
| a backup before messing with anything. All code release by me is         |
| considered sample code only. It may be fully functual, but you use it    |
| at your own risk, if you break it, you get to fix it too. No waranty is  |
| given or implied. All original header code and copyright messages        |
| will be maintained to give credit where credit is due. If you modify     |
| this, the only requirement is that you also maintain all original        |
| copyright messages. Released under GNU/General Public License.           |
|                                                                          |
| This program is free software; you can redistribute it and/or modify     |
| it under the terms of the GNU General Public License as published by     |
| the Free Software Foundation; either version 2 of the License, or        |
| (at your option) any later version.                                      |
+==========================================================================+
*/

/*
+--------------------------------------------------------------------------+
| This is where you can configured db table name and random hash strings   |
| to be used with this script.                                             |
|                                                                          |
| $asec_dbtable         The database table name to store copied records of |
|                       PHP-Nuke authors. Avoid spaces for db table name   |
|                       and use meaningless name related to your site.     |
|                                                                          |
| $asec_rand1,          Fill them with anything you like. Avoid using any  |
| $asec_rand2           special PHP characters unless you know the syntax  |
|                       of escaped strings. Combine numerics (0-9) and     |
|                       alphanumerics (A-Z, a-z) are recommended.          |
+--------------------------------------------------------------------------+
|  !!! PLEASE CHANGE THESE THREE VALUES AND DO NOT USING DEFAULT ONES !!!  |
+--------------------------------------------------------------------------+
*/

$asec_dbtable = "please_change_this_text";
$asec_rand1   = "d8h4dkodhnl98doiwjo7e9ifwp0r06wkn0jkdc8w8jsk3jdchs3gd7he3";
$asec_rand2   = "pnf7gss09dhf6ted3ndolss5sm398o6qkdlsdsd66kd7k3ldspq92mkkw";

/*
+--------------------------------------------------------------------------+
|                      DO NOT EDIT BELOW THIS LINE                         |
+--------------------------------------------------------------------------+
*/

function asec_fetchAdminCookie($admin) {
	global $prefix, $db;
	$ret['aid']  = "";
	$ret['name'] = "";
	$ret['pwd']  = "";
	$ret['sup']  = "";
	$ret['lang'] = "";
	if (!isset($admin)) { return $ret; }
	if(!is_array($admin)) {
		$array_admin = explode(":", base64_decode($admin));
		$aid = "$array_admin[0]";
		$pwd = "$array_admin[1]";
		$lng = "$array_admin[2]";
	} else {
		$aid = "$admin[0]";
		$pwd = "$admin[1]";
		$lng = "$admin[2]";
	}
	if (($aid == "") || ($pwd == "")) { return $ret; }
	$sql = "SELECT name, pwd, radminsuper FROM ".$prefix."_authors WHERE aid='$aid'";
	$result = $db->sql_query($sql);
	if (!$result) { return $ret; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return $ret; }
	$name = $row['name'];
	$sup  = $row['radminsuper'];
	$pass = $row['pwd'];
	if(($pass != $pwd) || ($pass == "")) { return $ret; }
	$ret['aid']  = $aid;
	$ret['name'] = $name;
	$ret['pwd']  = $pwd;
	$ret['sup']  = $sup;
	$ret['lang'] = $lng;
	return $ret;
}

function asec_createDB() {
	global $asec_dbtable, $db;
	$db->sql_query("DROP TABLE IF EXISTS ".$asec_dbtable);
	$sql = "CREATE TABLE ".$asec_dbtable." ("
		."aid varchar(25) NOT NULL default '', "
		."name varchar(50) NOT NULL default '', "
		."pwd varchar(40) NOT NULL default '', "
		."radminsuper int(1) NOT NULL default '0', "
		."lastupdate int(11) unsigned NOT NULL default '0', "
		."PRIMARY KEY (aid), "
		."KEY aid (aid), "
		."KEY name (name) "
		.") TYPE=MyISAM";
	if (!$db->sql_query($sql)) { return 0; }
	return 1;
}

function asec_checkSyncDB() {
	global $asec_dbtable, $prefix, $db;
	$num1 = $db->sql_numrows($db->sql_query("SELECT aid FROM ".$prefix."_authors"));
	$num2 = $db->sql_numrows($db->sql_query("SELECT aid FROM ".$asec_dbtable));
	if ($num1 != $num2) { return 0; }
	$result = $db->sql_query("SELECT name, aid, pwd, radminsuper FROM ".$prefix."_authors");
	if (!$result) { return 0; }
	while ($row = $db->sql_fetchrow($result)) {
		$name = $row['name'];
		$aid  = $row['aid'];
		$pwd  = $row['pwd'];
		$sup  = $row['radminsuper'];
		$result2 = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$asec_dbtable." WHERE aid='$aid'");
		if (!$result2) { return 0; }
		list($name2, $pwd2, $sup2) = $db->sql_fetchrow($result2);
		if (($name != $name2) || ($pwd != $pwd2) || ($sup != $sup2)) { return 0; }
	}
	return 1;
}

function asec_syncDB() {
	global $asec_dbtable, $prefix, $db;
	$lud = sprintf("%u", time());
	$result = $db->sql_query("SELECT name, aid, pwd, radminsuper FROM ".$prefix."_authors");
	if (!$result) { return 0; }
	while ($row = $db->sql_fetchrow($result)) {
		$name = $row['name'];
		$aid  = $row['aid'];
		$pwd  = $row['pwd'];
		$sup  = $row['radminsuper'];
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$aid'"));
		if ($num == 0) {
			$sql = "INSERT INTO ".$asec_dbtable." (name, aid, pwd, radminsuper, lastupdate) VALUES ('$name', '$aid', '$pwd', '$sup', '$lud')";
		} else {
			$sql = "UPDATE ".$asec_dbtable." SET pwd='$pwd', radminsuper='$sup', lastupdate='$lud' WHERE aid='$aid'";
		}
		$result2 = $db->sql_query($sql);
		if (!$result2) { return 0; }
	}
	$db->sql_query("DELETE FROM ".$asec_dbtable." WHERE lastupdate < $lud");
	return 1;
}

function asec_syncAdmin($aid) {
	global $asec_dbtable, $prefix, $db;
	$lud = sprintf("%u", time());
	$aid = substr($aid, 0, 25);
	$result = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$prefix."_authors WHERE aid='$aid'");
	if (!$result) { return 0; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return 0; }
	$name = $row['name'];
	$pwd  = $row['pwd'];
	$sup  = $row['radminsuper'];
	$num  = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$aid'"));
	if ($num == 0) {
		$sql = "INSERT INTO ".$asec_dbtable." (name, aid, pwd, radminsuper, lastupdate) VALUES ('$name', '$aid', '$pwd', '$sup', '$lud')";
	} else {
		$sql = "UPDATE ".$asec_dbtable." SET pwd='$pwd', radminsuper='$sup', lastupdate='$lud' WHERE aid='$aid'";
	}
	$result = $db->sql_query($sql);
	if (!$result) { return 0; }
	return 1;
}

function asec_unsyncAdmin($aid) {
	global $asec_dbtable, $db;
	$aid = substr($aid, 0, 25);
	$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$aid'"));
	if ($num == 1) {
		$sql = "DELETE FROM ".$asec_dbtable." WHERE aid='$aid'";
		$result = $db->sql_query($sql);
		if (!$result) { return 0; }
	}
	return 1;
}

function asec_isAccountMatch($aid) {
	global $asec_dbtable, $prefix, $db;
	$aid = substr($aid, 0, 25);
	$result1 = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$prefix."_authors WHERE aid='$aid'");
	if (!$result1) { return 0; }
	$r1 = $db->sql_fetchrow($result1);
	if (empty($r1)) { return 0; }
	$result2 = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$asec_dbtable." WHERE aid='$aid'");
	if (!$result2) { return 0; }
	$r2 = $db->sql_fetchrow($result2);
	if (empty($r2)) { return 0; }
	if (($r1['name'] != $r2['name']) || ($r1['pwd'] != $r2['pwd']) || ($r1['radminsuper'] != $r2['radminsuper'])) { return 0; }
	return 1;
}

function asec_isAdminAccountMatch($admin) {
	global $asec_dbtable, $db;
	$adm = asec_fetchAdminCookie($admin);
	if (($adm['aid'] == "") || ($adm['name'] == "") || ($adm['pwd'] == "")) { return 0; }
	$result = $db->sql_query("SELECT name, pwd, radminsuper FROM ".$asec_dbtable." WHERE aid='$adm[aid]'");
	if (!$result) { return 0; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return 0; }
	if (($adm['name'] != $row['name']) || ($adm['pwd'] != $row['pwd']) || ($adm['sup'] != $row['radminsuper'])) { return 0; }
	return 1;
}

function asec_isAdmin($admin) {
	global $asec_dbtable, $db;
	$adm = asec_fetchAdminCookie($admin);
	if (($adm['aid'] == "") || ($adm['name'] == "") || ($adm['pwd'] == "")) { return 0; }
	$sql = "SELECT name, pwd FROM ".$asec_dbtable." WHERE aid='$adm[aid]'";
	$result = $db->sql_query($sql);
	if (!$result) { return 0; }
	$row = $db->sql_fetchrow($result);
	if (empty($row)) { return 0; }
	if (($adm['name'] != $row['name']) || ($adm['pwd'] != $row['pwd'])) { return 0; }
	return 1;
}

function asec_isGodAdmin($admin) {
	$adm = asec_fetchAdminCookie($admin);
	if (($adm['aid'] == "") || ($adm['name'] == "") || ($adm['pwd'] == "")) { return 0; }
	$admin_name  = trim($adm['name']);
	if ($admin_name != "God") { return 0; }
	return 1;
}

function asec_base64Encode($string) {
	$btbl = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/=";
	$brep = "87MZH54FutsEBaAzyKxwvUTS321rON9qG6poDCn0mXWVlkjihgfRQPedcYJIb*-;L";
	$base = base64_encode($string);
	$bres = "";
	for ($i=0;$i<strlen($base);$i++) {
		$bpos  = strpos($btbl, substr($base,$i,1));
		$bres .= substr($brep,$bpos,1);
	}
	return $bres;
}

function asec_base64Decode($string) {
	$btbl = "87MZH54FutsEBaAzyKxwvUTS321rON9qG6poDCn0mXWVlkjihgfRQPedcYJIb*-;L";
	$brep = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz+/=";
	$base = trim($string);
	$bres = "";
	for ($i=0;$i<strlen($base);$i++) {
		$bpos  = strpos($btbl, substr($base,$i,1));
		$bres .= substr($brep,$bpos,1);
	}
	return base64_decode($bres);
}

function asec_getMagicValue() {
	global $asec_rand1, $asec_rand2;
	$kmd5 = md5("$asec_rand1"."$asec_rand2");
	$key1 = hexdec(substr($kmd5, 2,8));
	$key2 = hexdec(substr($kmd5,12,8));
	$keys = floatval($key1 + $key2);
	$ktbl = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
	$klen = strlen($ktbl);
	$kret = "";
	for ($i = 0; $i < 16; $i++) {
		$mods = intval($keys % $klen);
		$keys = floatval($keys / 5.0);
		$kret.= substr($ktbl,$mods,1);
	}
	return $kret;
}

function asec_createRecallCode($admin) {
	global $asec_dbname, $asec_rand1, $asec_rand2;
	$adm = asec_fetchAdminCookie($admin);
	$rc1 = "$adm[name]"."$asec_rand1"."$adm[aid]"."$asec_rand2"."$adm[pwd]"."$asec_dbname";
	$rc2 = "$adm[name]:$adm[aid]:$adm[pwd]";
	$mag = asec_getMagicValue();
	$mc1 = substr($mag,0,8);
	$mc2 = substr($mag,8,8);
	$cod = asec_base64Encode($rc2);
	$csz = intval(strlen($cod)/3);
	$co1 = substr($cod,0,$csz);
	$co2 = substr($cod,$csz,$csz);
	$co3 = substr($cod,$csz*2,$csz+2);
	$ret['auth'] = strtoupper(md5($rc1));
	$ret['code'] = $co1.$mc1.$co2.$mc2.$co3;
	return $ret;
}

function asec_checkRecallCode($auth, $code) {
	global $asec_dbname, $asec_rand1, $asec_rand2;
	$auth = strtoupper(trim($auth));
	$code = trim($code);
	if (($auth == "") || ($code == "")) { return 0; }
	$clen = intval((strlen($code)-16)/3);
	$base = substr($code,0,$clen).substr($code,$clen+8,$clen).substr($code,$clen*2+16,$clen+2);
	$mag1 = substr($code,$clen,8).substr($code,$clen*2+8,8);
	$mag2 = asec_getMagicValue();
	if ($mag1 != $mag2) { return 0; }
	list($name, $aid, $pwd) = explode(":", asec_base64Decode($base));
	$rc1 = "$name"."$asec_rand1"."$aid"."$asec_rand2"."$pwd"."$asec_dbname";
	$rc2 = strtoupper(md5($rc1));
	return ($rc2 == $auth) ? 1 : 0;
}

function asec_getApplied() {
	global $asec_dbtable, $prefix, $db;
	$ret['aid']  = array();
	$ret['name'] = array();
	$result = $db->sql_query("SELECT aid, name FROM ".$prefix."_authors");
	if (!result) { return $ret; }
	while ($row = $db->sql_fetchrow($result)) {
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$row[aid]'"));
		if ($num == 1) {
			if (asec_isAccountMatch($row['aid'])) {
				$ret['aid'][]  = "$row[aid]";
				$ret['name'][] = "$row[name]";
			}
		}
	}
	return $ret;
}

function asec_getNotApplied() {
	global $asec_dbtable, $prefix, $db;
	$ret['aid']  = array();
	$ret['name'] = array();
	$result = $db->sql_query("SELECT aid, name FROM ".$prefix."_authors");
	if (!result) { return $ret; }
	while ($row = $db->sql_fetchrow($result)) {
		$num = $db->sql_numrows($db->sql_query("SELECT * FROM ".$asec_dbtable." WHERE aid='$row[aid]'"));
		if ($num == 0) {
			$ret['aid'][]  = "$row[aid]";
			$ret['name'][] = "$row[name]";
		} else {
			if (!asec_isAccountMatch($row['aid'])) {
				$ret['aid'][]  = "$row[aid]";
				$ret['name'][] = "$row[name]";
			}
            }
	}
	return $ret;
}

?>
